precision highp float;

uniform float time;
uniform float alpha;
varying highp vec3 v_Grid;

lowp vec4 scanColor = vec4(0.2, 0.9, 0.7, 1);

void main() {
    float grid1 = (mod(atan(v_Grid.x, v_Grid.z) + time * 0.5, 3.1415926 * 2.0 / 3.0)) * 8.0;

    grid1 = 1.0 / (0.8 + grid1);
    grid1 = grid1 * ((1.0 - abs(v_Grid.y)));

    float gp1 = abs(mod(atan(v_Grid.z, v_Grid.x), 0.01));
    float gp2 = abs(mod(v_Grid.y, 0.01));
    if(gp1 < 0.003) {
        grid1 = 0.0;
    }
    if(gp2 < 0.003) {
        grid1 = 0.0;
    }

    grid1 = pow(grid1, 1.5);
    gl_FragColor = grid1 * scanColor * alpha;
}
